﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_03_DB_Bilder
Imports NM_Ahnen.cls_03_DB_Person_Neu
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_20_Blaettern
Imports NM_Ahnen.cls_91_DB_Para
Imports NM_Ahnen.NM_Ahnen_Search
Imports NM_Ahnen.NM_Ahnen_DB
Imports NM_Ahnen.NM_Ahnen_Info
Imports NM_Ahnen.NM_Ahnen_PersK

Class Cls_02_DB_Export_GedCom
    REM *************************************************************
    REM *  Exportieren der GEDCOM-Daten                             *
    REM *************************************************************
    Public Shared Sub Exp_GedCom()
        Dim Help_ID As Double = p_int_ID
        REM Dateifolder für Auswahl der GedComDatei
        Call ExGedCom_Auswahl()

        REM Öffnen der GM3-Datenbank mit Provider 4.0, Zieldatenbank in aktuelle DB
        'Call Open_ExGedCom()
        NM_Ahnen.Cursor = Cursors.WaitCursor
        REM Erstellen GEDCOM-Header
        Call Header_Gedcom()
        p_int_ID = 0
        REM Übertragen der Datenfelder Person
        Call Read_NM_DB()

        REM Übertragen der Datenfelder Familie/Ehe

        str_Ged_TAG = "0 TRLR"
        str_Ged_Daten = ""
        Call Ged_Write()
        p_int_ID = Help_ID
        NM_Ahnen.Cursor = Cursors.Default

    End Sub

    REM **************************************************************
    REM *  Dateiauswahl über OpenFileDialog                          *
    REM **************************************************************
    Public Shared Sub ExGedCom_Auswahl()

        str_LogFile = str_Directory + "/LogFile" + ".txt"
        Using sw As StreamWriter = File.CreateText(str_LogFile)
        End Using

    End Sub

    REM **************************************************************
    REM *   Erstellen der Headerdaten für GEDCOM                     *
    REM **************************************************************
    Public Shared Sub Header_Gedcom()
        str_Ged_TAG = "0 HEAD"
        str_Ged_Daten = ""
        Call Ged_Write()

        str_Ged_TAG = "1 GEDC"
        str_Ged_Daten = ""
        str_Ged_Fil = ""
        Call Ged_Write()

        str_Ged_TAG = "1 SOUR"
        str_Ged_Daten = "NM-Ahnen"
        Call Ged_Write()

        str_Ged_TAG = "2 VERS"
        str_Ged_Daten = "1.0"
        Call Ged_Write()

        str_Ged_TAG = "2 CORP"
        str_Ged_Daten = "Norbert Mende"
        Call Ged_Write()

        str_Ged_TAG = "3 ADDR"
        str_Ged_Daten = "Fritz-Winter-Weg 23"
        Call Ged_Write()

        str_Ged_TAG = "4 CONT"
        str_Ged_Daten = "59227 Ahlen"
        Call Ged_Write()

        str_Ged_TAG = "4 CONT"
        str_Ged_Daten = "Germany"
        Call Ged_Write()

        str_Ged_TAG = "2 VERS"
        str_Ged_Daten = "5.5.1"
        Call Ged_Write()

        str_Ged_TAG = "2 FORM"
        str_Ged_Daten = "Lineage Linked"
        Call Ged_Write()

        str_Ged_TAG = "1 CHAR"
        str_Ged_Daten = "UTF-8"
        Call Ged_Write()

        str_Ged_TAG = "1 PLAC"
        Call Ged_Write()

        str_Ged_TAG = "2 FORM"
        str_Ged_Daten = "Town, Area code, County, Region, Country, Subdivision"
        Call Ged_Write()

        str_Ged_TAG = "0 @S1@"
        str_Ged_Daten = "SUBM"
        Call Ged_Write()

    End Sub

    REM **************************************************************
    REM Lesen der NM-DB                                              *
    REM **************************************************************
    Public Shared Sub Read_NM_DB()

        For i77 = 0 To int_Ged_Anz
            dbl_ID = lng_ID(i77)
            Call Mask_Clear()
            Call Person_Read_t01_Basis()
            Call Person_Read_t02()
            Call Person_Read_t03()
            Call Person_Read_t13()

            Call Transfer_ExDaten()
        Next

        Call Person_Read_t04_Gedcom()
        For i77 = 1 To dbl_Max_T04
            str_Ged_TAG = "0 @F" & Ged_Ehe(i77).ToString + "@ FAM"
            str_Ged_Daten = ""
            Call Ged_Write()
            str_Ged_TAG = "1 HUSB"
            str_Ged_Daten = "@I" & Ged_P1(i77).ToString + "@"
            Call Ged_Write()
            str_Ged_TAG = "1 WIFE"
            str_Ged_Daten = "@I" & Ged_P2(i77).ToString + "@"
            Call Ged_Write()

            p_int_Vater = Ged_P1(i77)
            p_int_Mutter = Ged_P2(i77)
            Call Person_Read_t05_Geschwister()
            For i66 = 0 To int_Ges
                If p_int_Vater = tg_lng_IDV(i66) And p_int_Mutter = tg_lng_IDM(i66) Then
                    str_Ged_TAG = "1 CHIL"
                    str_Ged_Daten = "@I" + tg_lng_ID(i66).ToString + "@"
                    Call Ged_Write()
                End If
            Next

            dbl_Ehe41 = i77
            Call Person_Read_EheDaten()
            If int_Gedcom = 1 Then
                str_Ged_TAG = "1 MARR"
                Call Ged_Write()

                If p_str_EDat1_TT <> "" Then
                    Call Gedcom_Datum(p_str_EDat1_TT, p_str_EDat1_MM, p_str_EDat1_JJ)
                End If
                If p_str_EOrt1 <> "" Then
                    str_Ged_TAG = "2 PLAC"
                    str_Ged_Daten = p_str_EOrt1 & ",,,,,"
                    Ged_Ort = p_str_EOrt1
                    Call Gedcom_Ort()
                    Call Ged_Write()
                    Call Gedcom_Map()
                End If

                If p_str_EUrk1 <> "" Then
                    str_Ged_TAG = "2 SOUR"
                    str_Ged_Daten = p_str_Quelle(9)
                    If p_str_Quelle(10) <> "" Then str_Ged_Daten += " " & p_str_Quelle(10)
                    Call Ged_Write()
                End If

                If p_str_E_Bemerk <> "" Then
                    str_Ged_TAG = "2 NOTE"
                    str_Ged_Daten = p_str_E_Bemerk
                    Call Ged_Write()
                End If
            End If

        Next


    End Sub

    REM **************************************************************
    REM Übertragen der NM-Daten in GEDCOM-Struktur                   *
    REM **************************************************************
    Public Shared Sub Transfer_ExDaten()

        str_Ged_Fil = " "
        Call Gedcom_Indi()
        Call Gedcom_Name()
        Call Gedcom_Birth()
        Call Gedcom_Taufe()
        Call Gedcom_Death()
        Call Gedcom_Buri()

    End Sub

    Public Shared Sub Gedcom_Indi()
        str_Ged_TAG = "0 @I" + dbl_ID.ToString + "@"
        str_Ged_Daten = "INDI"
        Call Ged_Write()

        str_Ged_TAG = "1 IDNO"
        str_Ged_Daten = dbl_ID.ToString
        Call Ged_Write()

    End Sub

    Public Shared Sub Gedcom_Name()
        str_Ged_TAG = "1 NAME"
        str_Ged_Daten = p_str_Vorname & " /" & p_str_GebName & "/"
        Call Ged_Write()

        str_Ged_TAG = "1 SEX"
        str_Ged_Daten = p_str_Geschl
        Call Ged_Write()

        ' If p_str_Beruf > "" Then
        'str_Ged_TAG = "1 OCCU"
        'str_Ged_Daten = p_str_Beruf
        'Call Ged_Write()
        'End If

    End Sub

    Public Shared Sub Gedcom_Birth()
        If p_str_GDat_TT = "" And p_str_GDat_MM = "" And p_str_GDat_JJ = "" And p_str_GOrt = "" And p_str_GUrk = "" And p_str_GUrk2 = "" Then Exit Sub

        str_Ged_TAG = "1 BIRT"
        str_Ged_Fil = ""
        Call Ged_Write()

        If p_str_GDat_TT > "" Then
            Call Gedcom_Datum(p_str_GDat_TT, p_str_GDat_MM, p_str_GDat_JJ)
        End If

        If p_str_GOrt <> "" Then
            str_Ged_TAG = "2 PLAC"
            str_Ged_Daten = p_str_GOrt + ",,,,,"
            Ged_Ort = p_str_GOrt
            Call Gedcom_Ort()
            Call Ged_Write()
            Call Gedcom_Map()
        End If

        If p_str_GUrk <> "" Then
            str_Ged_TAG = "2 SOUR"
            str_Ged_Daten = p_str_Quelle(1)
            If p_str_Quelle(2) <> "" Then str_Ged_Daten += " " & p_str_Quelle(2)
            Call Ged_Write()
        End If

    End Sub

    Public Shared Sub Gedcom_Taufe()

        If p_str_Konf = "" And p_str_TDat_TT = "" And p_str_TDat_MM = "" And p_str_TDat_JJ = "" And p_str_TOrt = "" And p_str_TUrk = "" Then Exit Sub

        If p_str_Konf <> "" Then
            str_Ged_TAG = "1 RELI"
            str_Ged_Daten = p_str_Konf
            Call Ged_Write()
        End If

        str_Ged_TAG = "1 CHR"
        str_Ged_Fil = ""
        Call Ged_Write()

        If p_str_TDat_TT <> "" Then
            Call Gedcom_Datum(p_str_TDat_TT, p_str_TDat_MM, p_str_TDat_JJ)
        End If

        If p_str_TBemerk <> "" Then
            str_Ged_TAG = "2 NOTE"
            str_Ged_Daten = p_str_TBemerk
            Call Ged_Write()
        End If

        If p_str_TOrt <> "" Then
            str_Ged_TAG = "2 PLAC"
            str_Ged_Daten = p_str_TOrt + ",,,,,"
            Ged_Ort = p_str_TOrt
            Call Gedcom_Ort()
            Call Ged_Write()
            Call Gedcom_Map()
        End If

        If p_str_TUrk <> "" Then
            str_Ged_TAG = "2 SOUR"
            str_Ged_Daten = p_str_Quelle(5)
            Call Ged_Write()
        End If

    End Sub

    Public Shared Sub Gedcom_Ort()

        If Ged_Ort = "Ahlen" Then str_Ged_Daten = "Ahlen,59227,Kreis Warendorf,NORDRHEIN-WESTFALEN,DEUTSCHLAND,"
        If Ged_Ort = "Vorhelm" Then str_Ged_Daten = "Ahlen,59227,Kreis Warendorf,NORDRHEIN-WESTFALEN,DEUTSCHLAND,Vorhelm"
        If Ged_Ort = "Beckum" Then str_Ged_Daten = "Beckum,59269,Kreis Warendorf,NORDRHEIN-WESTFALEN,DEUTSCHLAND,"
        If Ged_Ort = "Harsewinkel" Then str_Ged_Daten = "Harsewinkel,33428,Kreis Gütersloh,NORDRHEIN-WESTFALEN,DEUTSCHLAND,"
        If Ged_Ort = "Altenberge" Then str_Ged_Daten = "Altenberge,48341,Kreis Steinfurt,NORDRHEIN-WESTFALEN,DEUTSCHLAND,"
        If Ged_Ort = "Stromberg" Then str_Ged_Daten = "Oelde,59302,Kreis Warendorf,NORDRHEIN-WESTFALEN,DEUTSCHLAND,Stromberg"

    End Sub

    Public Shared Sub Gedcom_Map()

        If Ged_Ort = "Ahlen" Then
            str_Ged_TAG = "3 MAP"
            Call Ged_Write()
            str_Ged_TAG = "4 LATI"
            str_Ged_Daten = "N51.763380"
            Call Ged_Write()
            str_Ged_TAG = "4 LONG"
            str_Ged_Daten = "E7.888700"
            Call Ged_Write()
        End If
        If Ged_Ort = "Altenberge" Then
            str_Ged_TAG = "3 MAP"
            Call Ged_Write()
            str_Ged_TAG = "4 LATI"
            str_Ged_Daten = "N52.046837"
            Call Ged_Write()
            str_Ged_TAG = "4 LONG"
            str_Ged_Daten = "E7.466989"
            Call Ged_Write()
        End If

    End Sub

    Public Shared Sub Gedcom_Death()
        If p_str_SDat_TT = "" And p_str_SDat_MM = "" And p_str_SDat_JJ = "" And p_str_SOrt = "" And p_str_SUrk = "" And p_str_SUrk2 = "" Then Exit Sub

        str_Ged_TAG = "1 DEAT"
        str_Ged_Fil = ""
        Call Ged_Write()

        If p_str_SDat_TT <> "" Then
            Call Gedcom_Datum(p_str_SDat_TT, p_str_SDat_MM, p_str_SDat_JJ)
        End If

        If p_str_SOrt <> "" Then
            str_Ged_TAG = "2 PLAC"
            str_Ged_Daten = p_str_SOrt + ",,,,,"
            Ged_Ort = p_str_SOrt
            Call Gedcom_Ort()
            Call Ged_Write()
            Call Gedcom_Map()
        End If

        If p_str_SUrk <> "" Then

            str_Ged_TAG = "2 SOUR"
            str_Ged_Daten = p_str_Quelle(3)
            If p_str_Quelle(4) <> "" Then str_Ged_Daten += " " & p_str_Quelle(4)
            Call Ged_Write()
        End If

    End Sub

    Public Shared Sub Gedcom_Buri()
        If p_str_BDat_TT = "" And p_str_BDat_MM = "" And p_str_BDat_JJ = "" And p_str_BOrt = "" And p_str_BUrk1 = "" And p_str_BUrk2 = "" And p_str_TodUrsache = "" Then Exit Sub
        str_Ged_TAG = "1 BURI"
        str_Ged_Fil = ""
        Call Ged_Write()

        If p_str_BDat_TT <> "" Then
            Call Gedcom_Datum(p_str_BDat_TT, p_str_BDat_MM, p_str_BDat_JJ)
        End If
        If p_str_BOrt <> "" Then
            str_Ged_TAG = "2 PLAC"
            str_Ged_Daten = p_str_BOrt + ",,,,,"
            Ged_Ort = p_str_BOrt
            Call Gedcom_Ort()
            Call Ged_Write()
            Call Gedcom_Map()
        End If

        If p_str_BUrk1 <> "" Then
            str_Ged_TAG = "2 SOUR"
            str_Ged_Daten = p_str_Quelle(7)
            If p_str_Quelle(8) <> "" Then str_Ged_Daten += " " & p_str_Quelle(8)
            Call Ged_Write()
        End If

        If p_str_TodUrsache <> "" Then
            str_Ged_TAG = "2 CAUS"
            str_Ged_Daten = p_str_TodUrsache
            Call Ged_Write()
        End If


    End Sub

    REM **************************************************************
    REM *  Schreiben in GEDCOM-Datei                                 *
    REM **************************************************************
    Public Shared Sub Ged_Write()

        Dim int_L2 As Integer = Len(str_Ged_Daten)
        Dim str_Ged_H1 As String
        Dim str_Ged_H2 As String
        Dim str_Ged_H3 As String
        str_Ged_H2 = ""
        str_Ged_H3 = ""

        If int_L2 > 200 Then
            str_Ged_H3 = Mid(str_Ged_Daten, 201, int_L2 - 200)
            str_Ged_Daten = Mid(str_Ged_Daten, 1, 200)
            int_L2 -= 100
        End If
        If int_L2 > 100 Then
            str_Ged_H1 = Mid(str_Ged_Daten, 1, 100)
            str_Ged_H2 = Mid(str_Ged_Daten, 101, int_L2 - 100)
            str_Ged_Daten = str_Ged_H1
        End If

        str_Ged_Satz = ""
        str_Ged_Satz = str_Ged_TAG + str_Ged_Fil + str_Ged_Daten

        Using sw As StreamWriter = File.AppendText(str_LogFile)
            sw.WriteLine(str_Ged_Satz)
        End Using

        If str_Ged_H2 <> "" Then
            str_Ged_Satz = "2 CONC " + str_Ged_H2
            Using sw As StreamWriter = File.AppendText(str_LogFile)
                sw.WriteLine(str_Ged_Satz)
            End Using
        End If

        If str_Ged_H3 <> "" Then
            str_Ged_Satz = "2 CONC " + str_Ged_H3
            Using sw As StreamWriter = File.AppendText(str_LogFile)
                sw.WriteLine(str_Ged_Satz)
            End Using
        End If

        str_Ged_TAG = ""
        str_Ged_Fil = " "
        str_Ged_Daten = ""

    End Sub

    Public Shared Sub Gedcom_Datum(ByVal Ged_TT As String, ByVal Ged_MM As String, ByVal Ged_JJ As String)

        If Ged_TT > "00" And Ged_TT < "32" Then
            str_Ged_TAG = "2 DATE"
            str_Ged_Daten = Ged_TT & "." & Ged_MM & "." & Ged_JJ
            Call Ged_Write()
        Else
            If Ged_TT = "<>" Then
                str_Ged_TAG = "2 DATE"
                str_Ged_Daten = "ABT " & Ged_JJ
                Call Ged_Write()
            Else
                If Ged_TT = ">=" Or Ged_TT = ">" Then
                    str_Ged_TAG = "2 DATE"
                    str_Ged_Daten = "AFT " & Ged_JJ
                    Call Ged_Write()
                Else
                    If Ged_TT = "<" Then
                        str_Ged_TAG = "2 DATE"
                        str_Ged_Daten = "BEF " & Ged_JJ
                        Call Ged_Write()
                    End If
                End If
            End If
        End If

    End Sub

    REM **************************************************************
    REM *  Öffnen der ausgewählten Ged-Datei                         *
    REM **************************************************************
    Public Shared Sub Open_ExGedCom()

        Dim fs As FileStream
        int_GedFound = 0
        int_GedAnz = 0
        int_Ged_Tab = 0
        Try
            fs = New FileStream(str_DBPfad1, FileMode.Open)
        Catch ex As IOException
            MsgBox(ex.Message)
            int_Total_Error = 1
            Exit Sub
        End Try
        Dim sw As New StreamReader(fs)
        REM *------------------------------------------------------*
        REM *  Ermitteln Datensätze der GedCom-Datei               *
        REM *------------------------------------------------------*

    End Sub

    Public Shared Sub GedCom_Anz()
        Dim i1 As Integer = str_Ged.IndexOf("INDI")
        If i1 > 0 Then int_GedAnz += 1

    End Sub

    Public Shared Sub GedCom_Type()
        Dim i1 As Integer
        i1 = str_Ged.IndexOf("INDI")
        If i1 > 0 Then
            Call GedCom_ID()
        End If
        i1 = str_Ged.IndexOf("FAM")
        If i1 > 0 Then
            Call GedCom_Fam()
        End If
    End Sub


    Public Shared Sub GedCom_ID()
        dbl_GedID = 0
        Dim str_ID As String
        Dim i2 As Integer = 0
        Dim i3 As Integer = 0
        Dim i4 As Integer = 0
        Dim i5 As Integer = Len(str_Ged)
        Dim i1 As Integer = str_Ged.IndexOf("INDI")
        If i1 < 1 Then Exit Sub
        For i2 = 1 To i5
            If i4 = 0 And i3 > 0 And Mid(str_Ged, i2, 1) = "@" Then i4 = i2 : Exit For
            If i3 = 0 And Mid(str_Ged, i2, 1) = "@" Then i3 = i2 + 2
        Next
        int_Ged_Tab += 1
        str_ID = Mid(str_Ged, i3, i4 - i3)
        dbl_GedID = Val(str_ID)
        Ged_ID(int_Ged_Tab) = dbl_GedID
        int_GedFound = 2
    End Sub

    Public Shared Sub GedCom_Fam()

    End Sub

    Public Shared Sub GedEhe1_ID()

    End Sub


    Public Shared Sub GedEhe2_ID()

    End Sub

    Public Shared Sub Ged_Merk_Clear()
        int_GdMerk_Birt = 0
        int_GdMerk_Buri = 0
        int_GdMerk_Chr = 0
        int_GdMerk_Deat = 0
        int_GdMerk_Reli = 0
    End Sub

End Class