﻿Imports System.Windows.Forms
Imports System.Drawing
Imports NM_Ahnen.cls_10_Mask
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.Cls_04_Util

Public Class Cls_09_Koeln

    REM ******************************************************************
    REM *  Stringkonvertierung nach Kölner Phonetik                      *
    REM ******************************************************************
    Public Shared Function KoelnKonvert(ByVal str_Koeln1 As String)

        Dim str_Koeln2 As String
        Dim int_i2 As Integer
        Dim int_i3 As Integer
        Dim int_i4 As Integer
        Dim str_K1 As String
        Dim str_K2 As String
        Dim str_K3 As String

        int_i2 = Len(str_Koeln1)
        str_Koeln2 = ""

        For int_i3 = 1 To int_i2

            REM *--------------------------------------------------------*
            REM *  Zwischenspeichern des aktuellen Zeichens              *
            REM *--------------------------------------------------------*
            str_K2 = Mid(str_Koeln1.ToUpper, int_i3, 1)

            REM *--------------------------------------------------------*
            REM *  Zwischenspeichern des Zeichens vor dem akt. Zeichen   *
            REM *--------------------------------------------------------*
            If int_i3 < int_i2 Then
                str_K3 = Mid(str_Koeln1.ToUpper, int_i3 + 1, 1)
            Else
                str_K3 = ""
            End If

            REM *--------------------------------------------------------*
            REM *  Zwischenspeichern des Zeichens nach dem akt. Zeichen  *
            REM *--------------------------------------------------------*
            If int_i3 > 1 Then
                str_K1 = Mid(str_Koeln1.ToUpper, int_i3 - 1, 1)
            Else
                str_K1 = ""
            End If

            REM *--------------------------------------------------------*
            REM *  Alphabetwerte abfragen und umsetzen                   *
            REM *--------------------------------------------------------*
            If str_K2 = "A" Then str_Koeln2 += "0"
            If str_K2 = "B" Then str_Koeln2 += "1"

            If str_K2 = "C" Then
                If int_i3 = 1 Then
                    If str_K3 = "A" Or
                        str_K3 = "H" Or
                        str_K3 = "K" Or
                        str_K3 = "L" Or
                        str_K3 = "O" Or
                        str_K3 = "Q" Or
                        str_K3 = "R" Or
                        str_K3 = "U" Or
                        str_K3 = "X" Then
                        str_Koeln2 += "4"
                    Else
                        str_Koeln2 += "8"
                    End If
                Else
                    If str_K3 = "A" Or
                        str_K3 = "H" Or
                        str_K3 = "O" Or
                        str_K3 = "Q" Or
                        str_K3 = "U" Or
                        str_K3 = "X" Then
                        If str_K1 = "S" Or
                            str_K1 = "Z" Then
                            str_Koeln2 += "8"
                        Else
                            str_Koeln2 += "4"
                        End If
                    End If
                End If
            End If

            If str_K2 = "D" Then
                If str_K3 = "C" Or
                    str_K3 = "S" Or
                    str_K3 = "Z" Then
                    str_Koeln2 += "8"
                Else
                    str_Koeln2 += "2"
                End If
            End If

            If str_K2 = "E" Then str_Koeln2 += "0"
            If str_K2 = "F" Then str_Koeln2 += "3"
            If str_K2 = "G" Then str_Koeln2 += "4"
            If str_K2 = "I" Then str_Koeln2 += "0"
            If str_K2 = "J" Then str_Koeln2 += "0"
            If str_K2 = "K" Then str_Koeln2 += "4"
            If str_K2 = "L" Then str_Koeln2 += "5"
            If str_K2 = "M" Then str_Koeln2 += "6"
            If str_K2 = "N" Then str_Koeln2 += "6"
            If str_K2 = "O" Then str_Koeln2 += "0"

            If str_K2 = "P" Then
                If str_K3 = "H" Then
                    str_Koeln2 += "3"
                Else
                    str_Koeln2 += "1"
                End If
            End If

            If str_K2 = "Q" Then str_Koeln2 += "4"
            If str_K2 = "R" Then str_Koeln2 += "7"
            If str_K2 = "S" Then str_Koeln2 += "8"

            If str_K2 = "T" Then
                If str_K3 = "C" Or
                    str_K3 = "S" Or
                    str_K3 = "Z" Then
                    str_Koeln2 += "8"
                Else
                    str_Koeln2 += "2"
                End If
            End If

            If str_K2 = "U" Then str_Koeln2 += "0"
            If str_K2 = "V" Then str_Koeln2 += "3"
            If str_K2 = "W" Then str_Koeln2 += "3"

            If str_K2 = "X" Then
                If str_K1 = "C" Or
                    str_K1 = "K" Or
                    str_K1 = "Q" Then
                    str_Koeln2 += "8"
                Else
                    str_Koeln2 += "48"
                End If
            End If

            If str_K2 = "Y" Then str_Koeln2 += "0"
            If str_K2 = "Z" Then str_Koeln2 += "8"
            If str_K2 = "Ä" Then str_Koeln2 += "0"
            If str_K2 = "Ö" Then str_Koeln2 += "0"
            If str_K2 = "Ü" Then str_Koeln2 += "0"
            If str_K2 = "ß" Then str_Koeln2 += "8"

        Next

        REM *------------------------------------------------------------*
        REM *  Umladen des Strings und Mehrfachzeichen entfernen         *
        REM *------------------------------------------------------------*
        str_Koeln1 = str_Koeln2
        str_Koeln2 = Mid(str_Koeln1, 1, 1)
        int_i4 = 1

        int_i2 = Len(str_Koeln1)
        For int_i3 = 2 To int_i2

            If Mid(str_Koeln1, int_i3, 1) <> Mid(str_Koeln2, int_i4, 1) Then
                str_Koeln2 += Mid(str_Koeln1, int_i3, 1)
                int_i4 += 1
            End If

        Next

        REM *------------------------------------------------------------*
        REM *  Umladen des Strings und Nullen entfernen                  *
        REM *  aber führende Null bleibt erhalten                        *
        REM *------------------------------------------------------------*
        str_Koeln1 = str_Koeln2
        str_Koeln2 = Mid(str_Koeln1, 1, 1)

        int_i2 = Len(str_Koeln1)
        For int_i3 = 2 To int_i2

            If Mid(str_Koeln1, int_i3, 1) <> "0" Then
                str_Koeln2 += Mid(str_Koeln1, int_i3, 1)
            End If

        Next

        Return str_Koeln2

    End Function

    REM ******************************************************************
    REM *  Bilden der Searchtabelle                                      *
    REM ******************************************************************
    Public Shared Sub SearchBuild(ByVal str_Search As String, ByVal FId As Double, ByVal Pos As Integer)

        Dim str_Sel_O As String

        If Len(str_Search) = 0 Or str_Search = "    " Then
            Exit Sub
        End If

        REM *------------------------------------------------------------*
        REM *  Zusammenbau des Insert-Strings für SQL                    *
        REM *------------------------------------------------------------*
        str_Sel_O = "(t21_ID, t21_SB, t21_FK_t01) "
        str_Sel_O += "values ('"
        str_Sel_O += dbl_ID.ToString + "', '"
        str_Sel_O += str_Search + "', '"
        str_Sel_O += p_int_ID.ToString + "')"

        mySelect.CommandText = "insert into t21_Search" + str_Sel_O

        Call DB_Execute()
        'dbl_Anz_Ins += 1

        REM *------------------------------------------------------------*
        REM *  ID nach jedem Insert um 1 erhöhen                         *
        REM *------------------------------------------------------------*
        dbl_ID += 1

    End Sub

    REM ******************************************************************
    REM *  DB-Tabellen updaten - Searchbegriffe Kölner Phonetik          *
    REM ******************************************************************
    Public Shared Sub Update_Search()
        REM * InfoMaske ausgeben
        int_Info_Type = 2
        NM_Ahnen_Info.Show()

        REM * Searchtabelle löschen
        mySelect.CommandText = "delete * from t21_Search"
        Call DB_Execute()

        Dim reader As OleDb.OleDbDataReader
        Dim int_i5 As Integer = 0
        Dim str_SB1 As String
        Dim str_SB2 As String
        Dim str_SB3 As String
        Dim str_SB4 As String
        Dim str_Sel_O As String


        REM *------------------------------------------------------------*
        REM *  Öffnen der ausgewählten Tabelle                           *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t01_Person"

        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        reader = mySelect.ExecuteReader()
        ReDim lg_ID(int_Anz)

        REM *------------------------------------------------------------*
        REM *  Tabelle durchlesen und ID in Array abspeichern            *
        REM *------------------------------------------------------------*
        Do While reader.Read()
            lg_ID(int_i5) = reader(0)
            int_i5 += 1
        Loop
        reader.Close()

        REM *------------------------------------------------------------*
        REM *  Einzeldatensätze verarbeiten                              *
        REM *------------------------------------------------------------*
        For int_i5 = 0 To int_Anz

            str_SB1 = ""
            str_SB2 = ""
            str_SB3 = ""
            str_SB4 = ""
            'If int_i5 = 1567 Then
            'dbl_T21_Max = 1
            'End If

            mySelect.CommandText = " select * from t01_Person where t01_ID = " + lg_ID(int_i5).ToString
            reader = mySelect.ExecuteReader()
            Try
                reader.Read()
                myNull = IsDBNull(reader("t01_Name"))
                If myNull = False Then
                    str_SB1 = reader("t01_Name")
                    Call Leerfeld(str_SB1)
                    str_SB1 = str_SearchX
                    str_SB1 = KoelnKonvert(str_SB1)
                End If
                myNull = IsDBNull(reader("t01_GebName"))
                If myNull = False Then
                    str_SB2 = reader("t01_GebName")
                    Call Leerfeld(str_SB2)
                    str_SB2 = str_SearchX
                    str_SB2 = KoelnKonvert(str_SB2)
                End If
                myNull = IsDBNull(reader("t01_SpitzN"))
                If myNull = False Then
                    str_SB3 = reader("t01_SpitzN")
                    Call Leerfeld(str_SB3)
                    str_SB3 = str_SearchX
                    str_SB3 = KoelnKonvert(str_SB3)
                End If
                myNull = IsDBNull(reader("t01_NameZ"))
                If myNull = False Then
                    str_SB4 = reader("t01_NameZ")
                    Call Leerfeld(str_SB4)
                    str_SB4 = str_SearchX
                    str_SB4 = KoelnKonvert(str_SB4)
                End If

            Catch ex As Exception

            End Try

            reader.Close()

            str_UString = ""
            If str_SB1 <> "" Then
                str_UString += "t01_Search_Name = '" + str_SB1 + "',"
            End If
            If str_SB2 <> "" And str_SB2 <> str_SB1 Then
                str_UString += "t01_Search_GebName = '" + str_SB2 + "',"
            Else
                str_SB2 = ""
            End If
            If str_SB3 <> "" And str_SB3 <> str_SB2 And str_SB2 <> str_SB1 Then
                str_UString += "t01_Search_SpitzN = '" + str_SB3 + "',"
            Else
                str_SB3 = ""
            End If
            If str_SB4 <> "" And str_SB4 <> str_SB3 And str_SB4 <> str_SB2 And str_SB4 <> str_SB1 Then
                str_UString += "t01_Search_NameZ = '" + str_SB4 + "',"
            Else
                str_SB4 = ""
            End If
            Call Komma_Delete()

            dbl_ID = lg_ID(int_i5).ToString

            If str_UString > "" Then Call Person_Update_T01()

            If str_SB1 <> "" Then
                Call DB_Tab_High("t21_ID", "t21_Search")
                dbl_Max_ID += 1
                REM *------------------------------------------------------------*
                REM *  Zusammenbau des Insert-Strings für SQL                    *
                REM *------------------------------------------------------------*
                str_Sel_O = "(t21_ID, t21_SB, t21_FK_t01) "
                str_Sel_O += "values ('"
                str_Sel_O += dbl_Max_ID.ToString + "', '"
                str_Sel_O += str_SB1 + "', '"
                str_Sel_O += dbl_ID.ToString + "')"

                mySelect.CommandText = "insert into t21_Search" + str_Sel_O
                Call DB_Execute()
            End If
            If str_SB2 <> "" Then
                Call DB_Tab_High("t21_ID", "t21_Search")
                dbl_Max_ID += 1
                REM *------------------------------------------------------------*
                REM *  Zusammenbau des Insert-Strings für SQL                    *
                REM *------------------------------------------------------------*
                str_Sel_O = "(t21_ID, t21_SB, t21_FK_t01) "
                str_Sel_O += "values ('"
                str_Sel_O += dbl_Max_ID.ToString + "', '"
                str_Sel_O += str_SB2 + "', '"
                str_Sel_O += dbl_ID.ToString + "')"

                mySelect.CommandText = "insert into t21_Search" + str_Sel_O
                Call DB_Execute()
            End If
            If str_SB3 <> "" Then
                Call DB_Tab_High("t21_ID", "t21_Search")
                dbl_Max_ID += 1
                REM *------------------------------------------------------------*
                REM *  Zusammenbau des Insert-Strings für SQL                    *
                REM *------------------------------------------------------------*
                str_Sel_O = "(t21_ID, t21_SB, t21_FK_t01) "
                str_Sel_O += "values ('"
                str_Sel_O += dbl_Max_ID.ToString + "', '"
                str_Sel_O += str_SB3 + "', '"
                str_Sel_O += dbl_ID.ToString + "')"

                mySelect.CommandText = "insert into t21_Search" + str_Sel_O
                Call DB_Execute()
            End If
            If str_SB4 <> "" Then
                Call DB_Tab_High("t21_ID", "t21_Search")
                dbl_Max_ID += 1
                REM *------------------------------------------------------------*
                REM *  Zusammenbau des Insert-Strings für SQL                    *
                REM *------------------------------------------------------------*
                str_Sel_O = "(t21_ID, t21_SB, t21_FK_t01) "
                str_Sel_O += "values ('"
                str_Sel_O += dbl_Max_ID.ToString + "', '"
                str_Sel_O += str_SB4 + "', '"
                str_Sel_O += dbl_ID.ToString + "')"

                mySelect.CommandText = "insert into t21_Search" + str_Sel_O
                Call DB_Execute()
            End If

        Next int_i5

        NM_Ahnen_Info.Close()
        NM_Ahnen.Cursor = Cursors.Default

    End Sub

    REM **************************************************************
    REM *  Leerzeichen aus Feld entfernen                            *
    REM **************************************************************
    Public Shared Sub Leerfeld(ByVal xx1 As String)

        Dim i_L1 As Integer = Len(xx1)
        Dim i_L2 As Integer

        For i_L2 = i_L1 To 1 Step -1
            If Mid(xx1, i_L2, 1) = " " Then Mid(xx1, i_L2, 1) = ""
        Next i_L2
        str_SearchX = xx1

    End Sub

End Class
